#include <stdio.h>

#include <Types.h>
#include <Files.h>

#ifndef THINK_C
#include <Strings.h>
#endif

#include <InternetConfig.h>

void DumpPrefs(void);

ICInstance inst;

void TestC ();
void TestC () {
	ICError err;
	Str255 emailAddress;
	long attr;
	long size;
	long seed;

	err = ICStart(&inst, 'CREA');			/* tell it your application creator */
	printf("ICStart: %ld\n", err);

	err = ICFindConfigFile(inst, 0, nil);
	printf("ICFindConfigFile: %ld\n", err);

	err = ICBegin(inst, icReadWritePerm);
	printf("ICBegin: %ld\n", err);
	size = sizeof(emailAddress);
	err = ICGetPref(inst, "\pEmail", &attr, (Ptr) emailAddress, &size);
	printf("ICGetPref: %ld\n", err);
	
	p2cstr(emailAddress);
	printf("Your Email address is %s\n", emailAddress);
	DumpPrefs();
	err = ICEnd(inst);
	printf("ICEnd: %ld\n", err);

	err = ICGetSeed(inst, &seed);
	printf("ICGetSeed: %ld = %ld\n", err, seed);
	/* now monitor this seed to see if any preferences have changed */

	err = ICStop(inst);
	printf("ICStop: %ld\n", err);
}

void DumpPrefs()
{
	ICError err;
	long count;
	long i;
	Str255 key;
	
	err = ICCountPref(inst, &count);
	printf("ICCountPref: %ld\n", err);
	for (i = 1; i <= count; i++) {
		err = ICGetIndPref(inst, i, key);
		p2cstr(key);
		printf("  ICGetIndPref: %ld - %s\n", err, &key);
	};
}

extern pascal void TestPascal(void);

void main(void)
{
	#define UsePascal 0
	#if UsePascal
		#if (GENERATINGCFM && GENERATING68K)
			#error Cannot use CFM-68K Pascal implementation because of problems with Metrowerks.
		#else
			printf("Test using Pascal.\n");
			TestP();
		#endif
	#else
		printf("Test using C.\n");
		TestC();
	#endif
}